# -*- coding:Utf-8 -*-
import es, gamethread, playerlib, langlib, popuplib

info = es.AddonInfo()
info.name = 'zm_invisible'
info.version = '1.1'
info.author = 'Phoval'
info.url = 'http://mattie.info/forums/'
info.description = 'Invisible for zombie !'
info.tags = 'zombie;invisible'

es.ServerVar('zm_invisible_version', info.version, 'zm_invisible: Version of the zm_invisible script').makepublic()
es.mexec('zm_invisible/config.cfg')
messages = langlib.Strings(es.getAddonPath('zm_invisible')+'/../../../cfg/zm_invisible/translations.ini')

def load():
	global joueurs, commandes, temps, nbrfois
	commandes = str(es.ServerVar('zmi_commandes')).split(',')
	temps = int(es.ServerVar('zmi_temps'))
	nbrfois = int(es.ServerVar('zmi_nbrfois'))
	joueurs = {}
	listejoueurs = es.getUseridList()
	for index in commandes:
		es.regsaycmd(index, 'zm_invisible/invisible', 'Invisibilit')
	for index in listejoueurs:
		joueurs[str(index)] = { 'now' : 0, 'fois' : 0 }
	

def unload():
	global joueurs, commandes
	for index in commandes:
		es.unregsaycmd(index)
	del joueurs
	del commandes

def round_start(event_var):
	global joueurs
	for userid in joueurs:
		joueurs[userid] = { 'now' : 0, 'fois' : 0 }

def player_connect(event_var):
	global joueurs
	joueurs[event_var['userid']] = { 'now' : 0, 'fois' : 0 }

def player_disconnect(event_var):
	global joueurs
	del joueurs[event_var['userid']]

def invisible():
	global joueurs, temps, nbrfois
	userid = str(es.getcmduserid())
	joueur = playerlib.getPlayer(userid)
	if joueur.attributes['teamid'] == 2:
		if joueur.attributes['isdead'] == 0:
			if joueurs[userid]['now'] == 0:
				if joueurs[userid]['fois'] < nbrfois:
					joueurs[userid]['now'] = 1
					joueurs[userid]['fois'] += 1
					tokens = { 'temps' : temps, 'pfois' : joueurs[userid]['fois'], 'nbrfois' : nbrfois }
					menu_inv = popuplib.create('menu_inv')
					menu_inv.addline(messages('invisible', opts = tokens, lang = joueur.get('lang')))
					menu_inv.send(userid)
					joueur.set('color', [255, 255, 255, 0])
					es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' addoutput "rendermode 1"')
					es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' alpha 0')
					gamethread.delayed(temps, visible, userid)

def visible(userid):
	global joueurs
	joueurs[userid]['now'] = 0
	joueur = playerlib.getPlayer(userid)
	joueur.set('color', [255, 255, 255, 255])
	es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' addoutput "rendermode 1"')
	es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' alpha 255')
